package org.jeecg.modules.plan.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import org.apache.commons.lang3.StringUtils;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.plan.entity.Plan;
import org.jeecg.modules.plan.entity.PlanV;
import org.jeecg.modules.plan.modal.PlanBo;
import org.jeecg.modules.plan.service.IPlanVService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;

 /**
 * @Description: 计划临时表(用于计划预测)
 * @Author: jeecg-boot
 * @Date:   2025-06-10
 * @Version: V1.0
 */
@Api(tags="计划临时表(用于计划预测)")
@RestController
@RequestMapping("/plan/planV")
@Slf4j
public class PlanVController extends JeecgController<PlanV, IPlanVService> {
	@Autowired
	private IPlanVService planVService;

	/**
	 * 分页列表查询
	 *
	 * @param planBo
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "计划临时表(用于计划预测)-分页列表查询")
	@ApiOperation(value="计划临时表(用于计划预测)-分页列表查询", notes="计划临时表(用于计划预测)-分页列表查询")
	@GetMapping(value = "/list")
	public Result<List<PlanV>> queryPageList(PlanBo planBo, HttpServletRequest req) {
		LambdaQueryWrapper<PlanV> queryWrapper = new LambdaQueryWrapper<>();
		if(StringUtils.isNotBlank(planBo.getCalMonthStart()) && StringUtils.isNotBlank(planBo.getCalMonthEnd())) {
			queryWrapper.between(PlanV::getCalDay,planBo.getCalMonthStart(),planBo.getCalMonthEnd());
		}
		return Result.OK(planVService.list(queryWrapper));
	}

	/**
	 *   添加
	 *
	 * @param planV
	 * @return
	 */
	@AutoLog(value = "计划临时表(用于计划预测)-添加")
	@ApiOperation(value="计划临时表(用于计划预测)-添加", notes="计划临时表(用于计划预测)-添加")
	//@RequiresPermissions("org.jeecg.modules:bu_plan_v:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody PlanV planV) {
		planVService.save(planV);
		return Result.OK("添加成功！");
	}

	/**
	 *  编辑
	 *
	 * @param planV
	 * @return
	 */
	@AutoLog(value = "计划临时表(用于计划预测)-编辑")
	@ApiOperation(value="计划临时表(用于计划预测)-编辑", notes="计划临时表(用于计划预测)-编辑")
	//@RequiresPermissions("org.jeecg.modules:bu_plan_v:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody PlanV planV) {
		planVService.updateById(planV);
		return Result.OK("编辑成功!");
	}

	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "计划临时表(用于计划预测)-通过id删除")
	@ApiOperation(value="计划临时表(用于计划预测)-通过id删除", notes="计划临时表(用于计划预测)-通过id删除")
	//@RequiresPermissions("org.jeecg.modules:bu_plan_v:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		planVService.removeById(id);
		return Result.OK("删除成功!");
	}

	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "计划临时表(用于计划预测)-批量删除")
	@ApiOperation(value="计划临时表(用于计划预测)-批量删除", notes="计划临时表(用于计划预测)-批量删除")
	//@RequiresPermissions("org.jeecg.modules:bu_plan_v:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.planVService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}

	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "计划临时表(用于计划预测)-通过id查询")
	@ApiOperation(value="计划临时表(用于计划预测)-通过id查询", notes="计划临时表(用于计划预测)-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<PlanV> queryById(@RequestParam(name="id",required=true) String id) {
		PlanV planV = planVService.getById(id);
		if(planV==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(planV);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param planV
    */
    //@RequiresPermissions("org.jeecg.modules:bu_plan_v:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, PlanV planV) {
        return super.exportXls(request, planV, PlanV.class, "计划临时表(用于计划预测)");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    //@RequiresPermissions("bu_plan_v:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, PlanV.class);
    }

	 /**
	  *  生成日计划
	  *
	  * @param plan
	  * @return
	  */
	 @AutoLog(value = "检修计划-生成日计划")
	 @ApiOperation(value="检修计划-生成日计划", notes="检修计划-生成日计划")
	 @PostMapping("/generate")
	 public Result<String> generate(@RequestBody PlanBo plan) {
		 try {
			 planVService.generatePlan(plan);
			 return Result.OK("生成计划成功!");
		 }catch (Exception e) {
			 return Result.error(e.getMessage());
		 }
	 }

}
